# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
try:
	from urllib import urlopen
except ImportError:
	from urllib.request import urlopen
try:
	from urllib import urlencode
except ImportError:
	from urllib.parse import urlencode
try:
	from urlparse import urlparse, parse_qs
except ImportError:
	from urllib.parse import urlparse, parse_qs
import re, json
from collections import OrderedDict
import cntv

def httpget(url):
	try:
		return urlopen(url).read()
	except:
		print url
		print 'captured'
		return False

def item(title, url, path = None, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	d = {'url': url}
	if path:
		d['path'] = '|'.join(path).encode('utf-8')
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(d), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

def get_node(url, path = None):
	o = urlparse(url)
	p = o.path.split('/')
	if o.path[-5:] == '.m3u8':
		play('', url)
		sys.exit(0)
	ret = False
	if o.netloc == 'tv.cctv.com':
		if p[-2] == 'videoset' and (p[-1] == '' or p[-1] == 'index.shtml'):
			ret = cntv.videoset(url)
		if p[-1][:4] == 'VIDE' and p[-1][-6:] == '.shtml':
			ret = cntv.play(url)
			if ret['success']:
				play(ret['title'], 'stack://' + ' , '.join(ret['url']))
				sys.exit(0)
	if o.netloc == 'api.cntv.cn':
		ret = cntv.videolist(url)
	if o.netloc == 'vdn.live.cntv.cn':
		ret = cntv.live(url)
	if ret:
		if ret['success'] == False:
			xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
			sys.exit(0)
		if 'item' in ret:
			for elem in ret['item']:
				item(elem['title'], elem['url'], isFolder = elem['folder'])
		if 'url' in ret:
			for elem in ret['url']:
				item(elem, ret['url'][elem], isFolder = False)
		xbmcplugin.endOfDirectory(handle)
		sys.exit(0)
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误代码: cntv 000')
		sys.exit(0)
	try:
		data = json.loads(content, object_pairs_hook = OrderedDict)
	except:
		xbmcgui.Dialog().ok('错误', '错误代码: cntv 001')
		sys.exit(0)
	if path:
		path1 = path.decode('utf-8').split('|')
	else:
		path1 = []
	for k in path1:
		data = data[k]
	for k in data:
		if isinstance(data[k], dict):
			item(k, url, path1 + [k])
		else:
			url1 = data[k]
			o = urlparse(url1)
			p = o.path.split('/')
			if o.path[-5:] == '.m3u8':
				item(k, url1, isFolder = False)
			elif o.netloc == 'tv.cctv.com' and p[-1][:4] == 'VIDE' and p[-1][-6:] == '.shtml':
				item(k, url1, isFolder = False)
			else:
				item(k, url1)
	xbmcplugin.endOfDirectory(handle)

handle = int(sys.argv[1])
if sys.argv[2] == '':
	get_node('http://ims.tian-le.com/cntv.json')
else:
	url = sys.argv[2]
	o = urlparse(url)
	q = parse_qs(o.query)
	url = q['url'][0]
	if 'path' in q:
		get_node(url, q['path'][0])
	else:
		get_node(url)
